var Jimp = require('jimp'),
    defaultThreshold = 50

function thresholdValues (thresh) {
  function initArray (size, value) {
    for(var i = 0, array = new Array(size); i < size; i++)
      array[i] = value;
    return array
  }
  function valOrDefault (v) {
    if (!v)
      return defaultThreshold
    return v
  }
  if (!thresh)
    return initArray(3, defaultThreshold)
  if (thresh.length)
    return thresh.map(valOrDefault)
  return initArray(3, thresh)
}

function grid (imgPath, w, h, cb, rgbaThresholds) {

  var out = new Array(h)
  var thresholds = thresholdValues(rgbaThresholds)

  function isBlackPixel (r, g, b, a) {
    if (r < thresholds[0] ||
        g < thresholds[1] ||
        b < thresholds[2] ||
        a < thresholds[3] )
      return true
    return false
  }

  Jimp.read(imgPath, function (err, img) {
    if (err) {
      cb(err, null)
      return
    }
    img
      .resize(w, h)
      .scan(0,0, w, h, function (x, y, idx) {
        var red   = this.bitmap.data[idx]
        var green = this.bitmap.data[idx + 1]
        var blue  = this.bitmap.data[idx + 2]
        var alpha = this.bitmap.data[idx + 3]
        if (!out[y]) {
          out[y] = new Array(w)
        }
        out[y][x] = isBlackPixel(red, green, blue, alpha)
      })
    cb(null, out)
  })
}

module.exports = grid
